extends Node2D

var dragging = false
var selected = []
var drag_start = Vector2.ZERO
var select_rect = RectangleShape2D.new()

func _unhandled_input(event):
	if event.is_action_pressed("ui_right"):
		$Camera2D.position.x += 10
	if event is InputEventMouseButton and event.button_index == BUTTON_LEFT:
		if event.pressed:
			if selected.size() == 0:
				dragging = true
				drag_start = get_global_mouse_position()
				printt(event.position, event.global_position, get_global_mouse_position())
			else:
				for item in selected:
					item.collider.target = get_global_mouse_position()
					item.collider.selected = false
				selected = []
				
		elif dragging:
			dragging = false
			update()
			var drag_end = get_global_mouse_position()
			select_rect.extents = (drag_end - drag_start) / 2
			var space = get_world_2d().direct_space_state
			var query = Physics2DShapeQueryParameters.new()
			query.set_shape(select_rect)
			query.transform = Transform2D(0, (drag_end + drag_start) / 2)
			selected = space.intersect_shape(query)
			for item in selected:
				item.collider.selected = true
			
	if event is InputEventMouseMotion and dragging:
		update()
		
func _draw():
	if dragging:
		draw_rect(Rect2(drag_start, get_global_mouse_position() - drag_start),
				Color(0.5, 0.5, 0.5), false)
	
	
